﻿using Excavator.Drawnings;
using Excavator.Exceptions;

namespace Excavator.CollectionGenericObjects;

/// <summary>
/// Реализация абстрактной компании - каршеринг 
/// </summary>
/// <remarks>
/// Конструктор
/// </remarks>
/// <param name="picWidth"></param>
/// <param name="picHeight"></param>
/// <param name="collection"></param>
public class Garage(int picWidth, int picHeight, ICollectionGenericObjects<DrawningTrackedVehicle> collection) : AbstractCompany(picWidth, picHeight, collection)
{
    Graphics g;
    int t = 5;
    protected override void DrawBackgound(Graphics g)
    {
        Pen pen = new(Color.Black, 3);
        for (int i = 0; i < _pictureWidth / _placeSizeWidth; i++)
        {
            for (int j = 0; j < _pictureHeight / _placeSizeHeight +
            1; ++j)
            {//линия разметки места
                g.DrawLine(pen, i * _placeSizeWidth, j *
                _placeSizeHeight * 2 , i * _placeSizeWidth + _placeSizeWidth / 2, j *
                _placeSizeHeight * 2);
            }
            this.g = g;
            g.DrawLine(pen, i * _placeSizeWidth, 0, i * _placeSizeWidth, _pictureHeight / _placeSizeHeight * _placeSizeHeight * 2);
        }
    }

    protected override void SetObjectsPosition()
    {
        int width = _pictureWidth / _placeSizeWidth;
        int height = _pictureHeight / _placeSizeHeight;

        int curWidth = width - 1;
        int curHeight = 0;

        for (int i = 0; i < (_collection?.Count ?? 0); i++)
        {
            try
            {
                int r = i / width;
                int s = width - 1 - (i % width);
                _collection.Get(i).SetPictureSize(_pictureWidth, _pictureHeight);
                _collection.Get(i).SetPosition(s * _placeSizeWidth + t, (r * _placeSizeHeight * 2) + t);
            }
            catch (ObjectNotFoundException) { }
            catch (PositionOutOfCollectionException e) { }
            if (curWidth > 0)
                curWidth--;
            else
            {
                curWidth = width - 1;
                curHeight++;
            }

            if (curHeight >= height)
            {
                return;
            }
        }
    }
}


